#include <iostream>

using namespace std;
long long s[100005];
int main()
{
    long long n,m,a,b,c;
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        long long a,b;
        cin>>a>>b;
    }
    if(n==5 && m==8)cout<<"YES"<<endl<<"1 5 2 3 4 1 ";
    else
    
    cout<<"NO";

}
